// Doulos Verification TechNote 1
// file TechNote1_Top.sv
//
// Top-level module instances the test harness
// and launches the OVM test.

module TechNote1_Top;

  timeunit 1ns; timeprecision 1ns;

  import ovm_pkg::*;
  import TechNote1_pkg::*;
  import TechNote1_test_pkg::*;

  // Test harness instance
  //
  TechNote1_TB tb();
  
  // Dummy variable needed to force import of the package
  //
  TechNote1_test dummy;
  
  initial begin

    // Configure test environment's virtual interface
    static SendRcvIntf_wrapper sr_intf_wrapper = new(tb.sr_intf);
    // Depending on whether your test uses the arrangment of
    // Figure 4 or Figure 6 of TechNote 1, the BFM component
    // may be named "compD" or "bfm".  We set up configurations
    // for both here; the unused one will be ignored.
    set_config_object("*.compD", "pins_wrapper", sr_intf_wrapper, 0);
    set_config_object("*.bfm", "pins_wrapper", sr_intf_wrapper, 0);

    // Allow the test to run for a reasonable time
    ovm_top.phase_timeout = 4us;

    // Run the test
    run_test("TechNote1_test");

  end

endmodule : TechNote1_Top
