// Doulos Verification TechNote 1
// file TechNote1_test_pkg.sv
//
// Package of test classes.  Various test-by-test
// configurations could be added in these tests.
// At present the only class is a very simple one
// that just instances the test environment.
// Despite this simplicity, it is necessary to
// create such a test class derived from ovm_test
// so that the run_test() function works correctly.

`include "ovm_macros.svh"

package TechNote1_test_pkg;

  timeunit 1ns; timeprecision 1ns;

  import ovm_pkg::*;
  import TechNote1_pkg::*;

  class TechNote1_test extends ovm_test;

    TechNote1_Fig6_env env;

    function new(string name, ovm_component parent = null);
      super.new(name, parent);
    endfunction : new

    function void build();
      super.build();
      env = TechNote1_Fig6_env::type_id::create("env", this);
    endfunction : build

    `ovm_component_utils(TechNote1_test)
  endclass : TechNote1_test

endpackage
